/***********************************************************************************************************************
 *
 * blueMarine Metadata - open source media workflow
 * Copyright (C) 2007-2011 by Tidalwave s.a.s. (http://www.tidalwave.it)
 *
 ***********************************************************************************************************************
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on
 * an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations under the License.
 *
 ***********************************************************************************************************************
 *
 * WWW: http://bluemarine.tidalwave.it
 * SCM: https://kenai.com/hg/bluemarine~metadata-src
 *
 **********************************************************************************************************************/
package it.tidalwave.metadata.impl;

import it.tidalwave.metadata.spi.TestSupport;
import java.beans.PropertyVetoException;
import java.io.IOException;
import it.tidalwave.metadata.Metadata;
import org.openide.loaders.DataObject;
import org.junit.After;
import org.junit.Before;
import org.junit.Test;
import static org.junit.Assert.*;

/*******************************************************************************
 *
 * @author  Fabrizio Giudici
 * @version $Id$
 *
 ******************************************************************************/
public class MetadataFactoryImplTest extends TestSupport
  {
    private MetadataFactoryImpl metadataFactory;
    
    @Before
    public void setUpFactory()
      throws PropertyVetoException, IOException 
      {
//        logger.info("********************** setup()");
        metadataFactory = new MetadataFactoryImpl();
      } 

    @After
    public void tearDownFactory() 
      {
        metadataFactory = null;
      }

    @Test
    public void findMetadata() 
      throws IOException
      {
        final DataObject dataObject1 = createDataObject("obj1");
        final Metadata metadata1a = metadataFactory.findOrCreateMetadata(dataObject1);
        assertNotNull(metadata1a);
        final Metadata metadata1b = metadataFactory.findOrCreateMetadata(dataObject1);
        assertNotNull(metadata1b);
        assertTrue(metadata1a == metadata1b);
        
        // FIXME: don't know why, it doesn't create the second DataObject
//        final DataObject dataObject2 = createDataObject("obj2");
//        final Metadata metadata2 = metadataFactory.findMetadata(dataObject2);
//        assertNotNull(metadata2);
//        assertTrue(metadata1a != metadata2);
      }
  }